#define IRLEDpin  2 // IR led for driving TV
#define rLEDpin   4 // red LED
#define wLEDpin   5 // white LED
#define buttonPin 15 // button
#define BITtime   562 //length of the carrier bit in microseconds
//put your own code here - 4 bytes (ADDR1 | ADDR2 | COMMAND1 | COMMAND2)
unsigned long IRcode=0x20DF10EF; // power for LG
unsigned long discretePOFF = 0x20DFA35C;

void setup() {
  // initialize IR LED as output.
  pinMode(IRLEDpin, OUTPUT);
  digitalWrite(IRLEDpin, LOW);
  
  // init red & white
  pinMode(wLEDpin, OUTPUT);
  pinMode(rLEDpin, OUTPUT);
  digitalWrite(rLEDpin, HIGH); //init at startup to see if board is powered and drain some current

  // for log
  Serial.begin(9600);

  // plugin button
  pinMode(buttonPin, INPUT_PULLUP);
  attachInterrupt(digitalPinToInterrupt(buttonPin), shutUpAndDown, LOW);
}

void shutUpAndDown() {
  digitalWrite(wLEDpin, HIGH);
  IRsendCode(IRcode);
  digitalWrite(wLEDpin, LOW);
  Serial.println();
  delayMicroseconds(40000);
}

// Ouput the 38KHz carrier frequency for the required time in microseconds
// This is timing critial and just do-able on an Arduino using the standard I/O functions.
// If you are using interrupts, ensure they disabled for the duration.
void IRcarrier(unsigned int IRtimemicroseconds)
{
  for(int i=0; i < (IRtimemicroseconds / 26); i++)
    {
    digitalWrite(IRLEDpin, HIGH);   //turn on the IR LED
    //NOTE: digitalWrite takes about 3.5us to execute, so we need to factor that into the timing.
    Serial.print("high");
    delayMicroseconds(9);          //delay for 13us (9us + digitalWrite), half the carrier frequnecy
    digitalWrite(IRLEDpin, LOW);    //turn off the IR LED
    Serial.print("low");
    delayMicroseconds(9);          //delay for 13us (9us + digitalWrite), half the carrier frequnecy
    }
}

//Sends the IR code in 4 byte NEC format
void IRsendCode(unsigned long code)
{
  //send the leading pulse
  IRcarrier(9000);            //9ms of carrier
  delayMicroseconds(4500);    //4.5ms of silence
  
  //send the user defined 4 byte/32bit code
  for (int i=0; i<32; i++)            //send all 4 bytes or 32 bits
    {
    IRcarrier(BITtime);               //turn on the carrier for one bit time
    if (code & 0x80000000)            //get the current bit by masking all but the MSB
      delayMicroseconds(3 * BITtime); //a HIGH is 3 bit time periods  
    else
      delayMicroseconds(BITtime);     //a LOW is only 1 bit time period
     code<<=1;                        //shift to the next bit for this byte
    }
  IRcarrier(BITtime);                 //send a single STOP bit.
}

void loop()                           //some demo main code
{
  // do nothiiiiiiiiiiiiiiiing
}
